"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b ||= {})
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
module.exports = function hljsCodeDiff(hljs) {
  function highlight(code, options) {
    if (!options.language.startsWith("diff:")) {
      return hljs.highlight(code, options);
    }
    const actualLanguage = options.language.slice("diff:".length);
    const diffLines = code.split("\n");
    const codeWithoutDiffMarkers = diffLines.map((line) => line.slice(1)).join("\n");
    const result = hljs.highlight(codeWithoutDiffMarkers, __spreadProps(__spreadValues({}, options), { language: actualLanguage }));
    const highlightedLines = result.value.split("\n");
    if (highlightedLines.length !== diffLines.length) {
      console.warn("[highlightjs-code-diff] failed to highlight because of line count mismatch");
      return hljs.highlight(code, __spreadProps(__spreadValues({}, options), { language: "diff" }));
    }
    const codeDiff = highlightedLines.map((line, i) => {
      const diffMarker = diffLines[i].slice(0, 1);
      switch (diffMarker) {
        case "+":
          return `<span class="hljs-addition">+${line}</span>`;
        case "-":
          return `<span class="hljs-deletion">-${line}</span>`;
        default:
          return `${diffMarker}${line}`;
      }
    }).join("\n");
    return __spreadProps(__spreadValues({}, result), {
      code,
      value: codeDiff,
      language: options.language
    });
  }
  return __spreadProps(__spreadValues({}, hljs), {
    highlight(codeOrLanguageName, optionsOrCode, ignoreIllegals) {
      return typeof optionsOrCode === "string" ? highlight(optionsOrCode, { language: codeOrLanguageName, ignoreIllegals }) : highlight(codeOrLanguageName, optionsOrCode);
    }
  });
};
